"""
Some code to profile the the AbstractMatrixGraph class 
"""

import numpy
import logging
import sys
import cProfile
import pstats
import os
from apgl.graph import *
from apgl.util import *

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

numVertices = 500
numFeatures = 0
vList = VertexList(numVertices, numFeatures)
graph = SparseGraph(vList)
generator = ErdosRenyiGenerator(graph)

p = 0.1

graph = generator.generateGraph(p)

outputDirectory = PathDefaults.getOutputDir()
directory = outputDirectory + "test/"
profileFileName = directory + "profile.cprof"

cProfile.runctx('graph.maxProductPaths()', globals(), locals(), profileFileName)
stats = pstats.Stats(profileFileName)
stats.strip_dirs().sort_stats("cumulative").print_stats(20)

#Can't think of a way to make it any faster other than an algorithmic change 