"""
Some code to profile the the AbstractSingleGraph class
"""

import numpy
import logging
import sys
import cProfile
import pstats
import os
from apgl.graph import *
from apgl.util import *

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

numVertices = 1000
numFeatures = 0
vList = VertexList(numVertices, numFeatures)
graph = SparseGraph(vList)
generator = ErdosRenyiGenerator(graph)

p = 0.1

graph = generator.generateGraph(p)

outputDirectory = PathDefaults.getOutputDir()
directory = outputDirectory + "test/"
profileFileName = directory + "profile.cprof"

#cProfile.runctx('graph.depthFirstSearch(0)', globals(), locals(), profileFileName)
cProfile.runctx('graph.findConnectedComponents()', globals(), locals(), profileFileName)
stats = pstats.Stats(profileFileName)
stats.strip_dirs().sort_stats("cumulative").print_stats(30)