import numpy
import logging
import sys
import cProfile
import pstats
import os
from apgl.graph import *
from apgl.util import *

logging.basicConfig(stream=sys.stdout, level=logging.INFO)


def profileSubraph():
    numVertices = 500
    numFeatures = 0
    vList = VertexList(numVertices, numFeatures)
    graph = SparseGraph(vList)
    generator = ErdosRenyiGenerator(graph)

    p = 0.1

    graph = generator.generateGraph(p)

    outputDirectory = PathDefaults.getOutputDir()
    directory = outputDirectory + "test/"
    profileFileName = directory + "profile.cprof"

    indices = numpy.random.permutation(numVertices)

    cProfile.runctx('graph.getSubGraph(indices)', globals(), locals(), profileFileName)
    stats = pstats.Stats(profileFileName)
    stats.strip_dirs().sort_stats("cumulative").print_stats(20)


def profileDiameter():
    numVertices = 1000
    numFeatures = 0
    vList = VertexList(numVertices, numFeatures)
    graph = SparseGraph(vList)
    generator = ErdosRenyiGenerator(graph)

    p = 0.1

    graph = generator.generateGraph(p)

    outputDirectory = PathDefaults.getOutputDir()
    directory = outputDirectory + "test/"
    profileFileName = directory + "profile.cprof"

    indices = numpy.random.permutation(numVertices)

    cProfile.runctx('graph.diameter()', globals(), locals(), profileFileName)
    stats = pstats.Stats(profileFileName)
    stats.strip_dirs().sort_stats("cumulative").print_stats(20)

profileDiameter()