
from apgl.graph import *
from apgl.util import *
import numpy


class Sampling(object):
    def __init__(self, degree):
        pass

    @staticmethod
    def crossValidation(folds, numExamples):
        """
        Returns a list of tuples (trainIndices, testIndices) using k-fold cross
        validation. 
        """
        Parameter.checkInt(folds, 1, numExamples)
        Parameter.checkInt(numExamples, 2, float('inf'))

        foldSize = int(numpy.floor(numExamples/folds))
        indexList = []

        for i in range(0, folds):
            testIndices = range(foldSize*i, foldSize*(i+1))
            trainIndices = numpy.setdiff1d(numpy.arange(0, numExamples), numpy.array(testIndices)).tolist()
            indexList.append((trainIndices, testIndices))

        return indexList 
        