
from apgl.viroscopy.HIVGraphReader import HIVGraphReader
from apgl.kernel.RandWalkGraphKernel import RandWalkGraphKernel
import logging
import sys
import mlpy
import numpy 

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

"""
A script to load up the HIV data in its entirity. 
"""
hivReader = HIVGraphReader()
graph = hivReader.readHIVGraph()

#The set of edges indexed by zeros is the contact graph
#The ones indexed by 1 is the infection graph
edgeTypeIndex1 = 0
edgeTypeIndex2 = 1
sGraphContact = graph.getSparseGraph(edgeTypeIndex1)
sGraphInfect = graph.getSparseGraph(edgeTypeIndex2)
sGraphContact.edgeAddition(sGraphInfect)

sGraph = sGraphContact

class KernelDistance():
    def __init__(self, graphList, kernel):
        self.graphList = graphList
        self.kernel = kernel

    def compute(self, x, y):
        """
        The vectors x and y are just indices 
        """
        dist = self.kernel.evaluate(self.graphList[x], self.graphList[x])
        dist = dist - 2*self.kernel.evaluate(self.graphList[x], self.graphList[y])
        dist = dist + self.kernel.evaluate(self.graphList[y], self.graphList[y])

        return dist 

    kernel = None
    graphList = None

#Let's create a graph list composed of all the ego graphs
graphList = []

for i in range(sGraph.getNumVertices()):
    egoGraph = sGraph.egoGraph(i)
    graphList.append(egoGraph)
    

lmbda = 0.1
graphKernel = RandWalkGraphKernel(lmbda)
graphDistance = KernelDistance(graphList, graphKernel)
indices = numpy.array(range(0, sGraph.getNumVertices()))

k = 5
km = mlpy.Kmedoids(k, dist=graphDistance)
m, n, cl, co = km.compute(indices)
