

import unittest
from apgl.viroscopy.HIVIndividual import HIVIndividual


class  HIVIndividualTest(unittest.TestCase):
    def setup(self):
        pass 

    def testContructor(self):
        person = HIVIndividual()

    def testGetSetDateOfBirth(self):
        person = HIVIndividual()
        person.setDateOfBirth(10.1)

        self.assertTrue(person.getDateOfBirth() == 10.1)
        self.assertRaises(ValueError, person.setDateOfBirth, -0.1)

    def testGetAge(self):
        person = HIVIndividual()
        person.setDateOfBirth(10.0)

        self.assertTrue(person.getAge(11.0) == 1.0)

    def testGetSetGender(self):
        person = HIVIndividual()
        person.setGender(1)

        self.assertTrue(person.getGender() == 1)
        self.assertRaises(ValueError, person.setGender, -1)
        self.assertRaises(ValueError, person.setGender, 2)

    def testGetSetOrientation(self):
        person = HIVIndividual()
        person.setGender(1)
        person.setOrientation(1)

        self.assertTrue(person.getOrientation() == 1)
        self.assertRaises(ValueError, person.setOrientation, -1)
        self.assertRaises(ValueError, person.setOrientation, 3)

    def testGetSetFreeDegree(self):
        person = HIVIndividual()
        person.setFreeDegree(5)

        self.assertTrue(person.getFreeDegree() == 5)
        self.assertRaises(ValueError, person.setFreeDegree, -1)
        self.assertRaises(ValueError, person.setFreeDegree, 2.1)

    def testGetSetState(self):
        person = HIVIndividual()
        person.setState(2)

        self.assertTrue(person.getState() == 2)
        self.assertRaises(ValueError, person.setState, -1)
        self.assertRaises(ValueError, person.setState, 1.2)
        self.assertRaises(ValueError, person.setState, 3)

    def testSetInfected(self):
        person = HIVIndividual()
        person.setFreeDegree(2)
        person.setInfected(2.0)

        self.assertEquals(person.getInfectionTime(), 2.0)
        self.assertEquals(person.getFreeDegree(), 1)
        self.assertEquals(person.getState(), 1)
        self.assertRaises(ValueError, person.setInfected, 1.0)

    def testSetDetected(self):
        person = HIVIndividual()
        person.setFreeDegree(2)
        person.setInfected(1.0)
        person.setDetected(2.0)

        self.assertEquals(person.getInfectionTime(), 1.0)
        self.assertEquals(person.getDetectionTime(), 2.0)
        self.assertEquals(person.getState(), 2)

        person = HIVIndividual()
        person.setFreeDegree(2)
        self.assertRaises(ValueError, person.setDetected, 1.0)

        person.setInfected(1.0)
        self.assertRaises(ValueError, person.setDetected, -1.0)

    def testStr(self):
        person = HIVIndividual()

        print(person)

if __name__ == '__main__':
    unittest.main()

